////////////////////////////////////////////////////////////
// SNAP25 - Concentration Game with JavaScript
// version 1.0 - 1999/01/13
// version 2.0 - 1999/03/03
// version 3.0 - 2009/02/15
// COPYRIGHT(C) KOJI MORITA (MORIBAN) , KOBE JAPAN
// moriban@hotmail.com
////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
// ユーザ調整用変数

// 画面配置 横カード枚数
var cardx=5;

// 画面配置 縦カード枚数
var cardy=5;

// 画面配置 カード1枚の横幅
var cardwidth=100;

// 画面配置 カード1枚の縦幅
var cardheight=100;

// カードの画像ファイルの拡張子
var cardfileextension=".jpg";

// 制限時間（秒、最大 999秒）
var timeLimit=120;

// ゲームクリア後の画像切り替え時間（秒）
var timeImageChange=2;
////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
// 変数（ユーザによる変更は不可）

// 一時変数
var a,i,j,now;

// 画面配置カード枚数（合計）
var card=cardx*cardy;

// カード種類数
var pair=Math.ceil(card/2);

// クリアまでの残り組数
var rest=Math.floor(card/2);

// 残り時間（ミリ秒）
var gametimer=timeLimit*1000;

// タイマー用の変数
var starttime;
var nowtime;

// ターン管理用変数（0=ゲーム開始前、1=カード未選択、2=カード1枚選択、3=ゲームクリア）
var turn=0;

// 選択されたカードのマッチング管理用変数（0=不正解、1=正解）
var answer=1;

// ゲームクリア後の画像切り替え用変数
restc=1;
////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
// 配列準備

function MakeArray(n){this.length=n;}


// 選択されたカードの管理用変数
select=new MakeArray(2);

// タイマー用数字の画像ファイル
numimg=new MakeArray(9);

// インフォメーション画面用の画像ファイル
infoimg=new MakeArray(2);

// カードの画像ファイル（大）
cardimg=new MakeArray(pair);

// カードの画像ファイル（小）
cardimgs=new MakeArray(pair+2);

// カードの管理用変数
cardnum=new MakeArray(pair*2);

// カードシャッフル用変数
sf=new MakeArray(pair*2);

// カードオープン判定変数
opencard=new MakeArray(card);
////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
// ゲームの初期化


// カードの画像ファイルの読み込み
for(i=1;i<=pair;i++){
	cardnum[i*2-1]=i;
	cardnum[i*2]=i;
	cardimg[i]=new Image;
	cardimg[i].src="originalimg/"+i+cardfileextension;
	cardimgs[i]=new Image;
	cardimgs[i].src="originalimg/"+i+"-small"+cardfileextension;
}


// オープン前カードの画像ファイルの読み込み
for(i=1;i<=2;i++){
	cardimgs[i+pair]=new Image;
	cardimgs[i+pair].src="img/cardimg-small"+i+".gif";
}


// インフォメーション画面用の画像ファイルの読み込み
for(i=0;i<=2;i++){
	infoimg[i]=new Image;
}

infoimg[0].src="img/cardimg-big.gif";
infoimg[1].src="img/lose.gif";
infoimg[2].src="img/gameover.gif";


// タイマー用数字の画像ファイルの読み込み
for(i=0;i<=9;i++){
	numimg[i]=new Image;
	numimg[i].src="img/"+i+".gif";
}


// カードシャッフル用変数の初期化
for(i=1;i<=pair*2;i++){
	sf[i]=i;
}


// カード配置をシャッフル
for(i=pair*2;i>1;i--){
	j=Math.floor(pair*2*Math.random()+1);
	a=sf[i];
	sf[i]=sf[j];
	sf[j]=a;
}


// カードオープン判定変数の初期化
for(i=1;i<=card;i++){
	opencard[i]=1;
}
////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
// ゲーム用の処理


// カードにマウスオーバーした際の処理
function mo(n){
	if((opencard[n]==1)&&(gametimer>0)){
		document.images[n-1].src=cardimgs[pair+2].src;
		return true
	}
}


// カードからマウスアウトした際の処理
function mt(n){
	if((opencard[n]==1)&&(gametimer>0)){
		document.images[n-1].src=cardimgs[pair+1].src;
		return true
	}
}


// カードが選択された際の処理
function selectCard(n){
	if((opencard[n]==1)&&(gametimer>0)&&(turn!=3)){

	// ゲームスタート時の処理
	if(turn==0){
		now = new Date();
		starttime = now.getTime();
		turn=1;
		timer();
	}

	if(turn==1){
		if(answer==0){
			document.images[select[1]-1].src=cardimgs[pair+1].src;
			document.images[select[2]-1].src=cardimgs[pair+1].src;
			opencard[select[1]]=1;
			opencard[select[2]]=1;
		}

		parent.chara_frame.location="message/charag.html";
		document.images[n-1].src=cardimgs[cardnum[sf[n]]].src;
		parent.info_frame.document.images[7].src=infoimg[0].src;

		select[1]=n;
		opencard[n]=0;
	}

	if(turn==2){
		document.images[n-1].src=cardimgs[cardnum[sf[n]]].src;

		select[2]=n;
		answer=0;
		opencard[n]=0;

		if(cardnum[sf[select[1]]]==cardnum[sf[select[2]]]){
			// 正解時の処理
			parent.info_frame.document.images[7].src=cardimg[cardnum[sf[n]]].src;
			parent.chara_frame.location="message/chara"+cardnum[sf[n]]+".html";
			answer=1;
			rest=rest-1;

			// ゲームクリア時の処理
			if(rest==0){
				clearTimeout(tid);
				restc=cardnum[sf[n]];
				turn=3
				gameClear();
				return true
			}
		}
		else{
			// 不正解時の処理
			parent.info_frame.document.images[7].src=infoimg[1].src;
			parent.chara_frame.location="message/charaf.html";
		}
	}

	turn=3-turn;
	}
}


// カード1枚を画面に描画する処理
function printCard(n){
	document.write("<td><a href='JavaScript:;' onClick='selectCard("+n+")' onMouseOver='mo("+n+")' onMouseOut='mt("+n+")'><img src='img/cardimg-small1.gif' width='"+cardwidth+"' height='"+cardheight+"' border='0'></a></td>");
}


// カードを画面に配置する処理
function arrangeCard(n){
	for(i=0;i<=cardy-1;i++){
		document.write("<tr>");

		for(j=1;j<=cardx;j++){
			a=i*cardx+j;
			printCard(a);
		}

		document.write("</tr>");
	}
}


// タイマーの数字を画面に描画する処理
function printTimer(){
	parent.info_frame.document.images[2].src=numimg[Math.floor(gametimer/100000)%10].src;
	parent.info_frame.document.images[3].src=numimg[Math.floor(gametimer/10000)%10].src;
	parent.info_frame.document.images[4].src=numimg[Math.floor(gametimer/1000)%10].src;
	parent.info_frame.document.images[6].src=numimg[Math.floor(gametimer/100)%10].src;
}


// タイマー処理
function timer(){
	tid=setTimeout("timer()",200);

	if(gametimer>0){
		now = new Date();
		nowtime = now.getTime();
		gametimer=timeLimit*1000-(nowtime-starttime);
	}
	else{
		clearTimeout(tid);

		parent.info_frame.document.images[7].src=infoimg[2].src;
		parent.chara_frame.location="message/charao.html";

		gametimer=0;
	}

	printTimer();
}


// 読み込み完了時の処理（onLoadイベントで起動）
function gameStart(){
	printTimer();
	parent.chara_frame.location="message/charaq.html";
}


// ゲームクリア後の処理
function gameClear(){
	tid=setTimeout("gameClear()",timeImageChange*1000);

	parent.info_frame.document.images[7].src=cardimg[restc].src;
	parent.chara_frame.location="message/chara"+restc+".html";

	restc=restc+1;
	if(restc>pair){restc=1}
}
////////////////////////////////////////////////////////////
